library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
 
entity control_mux2 is
   port
   (
      a, b : in std_logic; 
      sel : in std_logic;
		result : out std_logic
   );
end entity control_mux2;
 
architecture rtl of control_mux2 is
begin 
   process (a, b, sel) is
   begin
      case sel is
         when '1'  => result <= a;
         when '0'  => result <= b;
         when others => result <= b;		
      end case;
   end process;
end architecture rtl;
