library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
 
entity data_mux2 is
   port
   (
      a, b : in std_logic_vector(63 downto 0); 
      sel : in std_logic;
		result : out std_logic_vector(63 downto 0)
   );
end entity data_mux2;
 
architecture rtl of data_mux2 is
begin 
   process (a, b, sel) is
   begin
      case sel is
         when '1'  => result <= a;
         when '0'  => result <= b;
         when others => result <= b;		
      end case;
   end process;
end architecture rtl;
