library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
 
entity data_mux8 is
   port
   (
      a, b, c, d, e, f, g, h : in std_logic_vector(63 downto 0); 
      sel : in std_logic_vector(2 downto 0);
		result : out std_logic_vector(63 downto 0)
   );
end entity data_mux8;
 
architecture rtl of data_mux8 is
begin 
   process (a, b, c, d, e, f, g, h, sel) is
   begin
      case sel is
         when "111"  => result <= a;
         when "000"  => result <= b;
			when "001"  => result <= c;
			when "010"  => result <= d;
			when "011"  => result <= e;
			when "100"  => result <= f;
			when "110"  => result <= g;
			when "101"  => result <= h;
         when others => result <= a;		
      end case;
   end process;
end architecture rtl;
