#include <iostream>
#include <fstream>
#include <time.h>
#include "Matrix.h"

using namespace std;

void main(){
	ifstream myfile ("testmatrise20.txt");
	ofstream resultatfil ("Resultat20.txt");
	bool debug = 1;
	bool error = 1;
	//[rad,nedover][kolonne, bortover]
	Matrix<double> A;
	myfile >> A;
	Matrix<double> b(A.GetRows(),1);
	Matrix<double> x(A.GetRows(),1);
	Matrix<double> z(A.GetRows(),1);
	Matrix<double> c(A.GetRows(),1);
	Matrix<double> alfa;
	Matrix<double> beta;
	Matrix<double> r;
	Matrix<double> d;
	Matrix<double> delta_new;
	Matrix<double> delta_old;

	double XMax = 10;
	double XMin = 0;
	double temp;
	int teller = 0;
	
	srand((unsigned)time(0)); 
	
	for(int i=0; i < A.GetRows(); i++){
		//double r = double(rand())/(double(RAND_MAX)+1.0); // random double in range 0.0 to 1.0 (non inclusive)
		//double random = XMin + r*(XMax - XMin); // transform to wanted range
		b[i][0] = 1000;//i+3;//random;
		x[i][0] = 0;
	}
	
	r = b;// - A*x;

	//for(int i=0; i <  A.GetRows(); i++){
	//	temp = A[i][i];
	//	c[i][0] = 1/temp;
		//z[i][0] = (1/temp)*b[i][0];
	//};
	//z = c%r;

	//d = z;
	d = r;

	cout << "COMPUTING..." << endl;
	//cout << "z" << endl;
	//cout << z << endl;
	//test2 = test.ludecomp();
	//cout << test2;
	
	
	//delta_new = (!z*r);
	delta_new = (!r*r);
	for(teller = 0; teller < 40000; teller++){
		//if( r.norm() < 1e-6 ) break;
		if(debug)resultatfil << "q: " << A*d << endl;
		if(debug) resultatfil << "dq: " << (!d*A*d) << endl;
		//alfa = (!z*r)/(!d*A*d);
		alfa = (!r*r)/(!d*A*d);
		if(debug)resultatfil << "Alfa: " << alfa << endl;
		x = x + d*alfa;
		if(error){
			if(teller%50 == 0)r = b - A*x;
			else r = r - A*d*alfa;
		}
		else r = r - A*d*alfa;
		
		//for(int i=0; i <  A.GetRows(); i++){
		//	temp = A[i][i];
			//z[i][0] = (1/temp)*r[i][0];
	    //};
		//for(int i=0; i < A.GetRows(); i++){
		//z = c%r;
		//}

		delta_old = delta_new;//(!r1*r1);
		if(debug)resultatfil << "Delta_old: " << delta_old << endl;
		//delta_new = (!z*r);
		delta_new = (!r*r);
		if(debug)resultatfil << "Delta_new: " << delta_new << endl;
		if( delta_new.toDouble() < 1e-6 ) break;
		beta = delta_new/delta_old;
		//beta = (!r2*r2)/(!r1*r1);
		if(debug)resultatfil << "Beta: " << beta << endl;
		//d = z + d*beta;
		d = r + d*beta;
		if(debug)resultatfil << "d: " << d << endl;
		//r1=r2;
		if(debug)resultatfil << "Iterasjon:" << teller+1 << endl << "r= " << endl << r << endl << "x= " << endl << x << endl;
	}
	//resultatfil << "B=" << endl;
	resultatfil << teller << endl;
	resultatfil << "Lengden av r: " << r.norm() << endl;
	
	resultatfil << x << endl;
	resultatfil << b;
	cout << x;
	resultatfil.close();
	myfile.close();
}
	