library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
 
entity control_mux4 is
   port
   (
      a, b, c, d : in std_logic; 
      sel : in std_logic_vector(1 downto 0);
		result : out std_logic
   );
end entity control_mux4;
 
architecture rtl of control_mux4 is
begin 
   process (a, b, c, d, sel) is
   begin
      case sel is
         when "11"  => result <= a;
         when "00"  => result <= b;
			when "01"  => result <= c;
			when "10"  => result <= d;
         when others => result <= d;		
      end case;
   end process;
end architecture rtl;
