library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
 
entity flip_flop is
   port
   (
		clk, reset, d : in std_logic;
		q : out std_logic
   );
end entity flip_flop;

architecture rtl of flip_flop is
begin
process(clk)
begin
  if (reset = '1') then
    q <= '0';
  elsif rising_edge(clk) then
    q <= d;
  end if;
end process;

end rtl;