LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY flip_flop IS

PORT (
	clk 		: 			IN STD_LOGIC;
	reset    :        IN STD_LOGIC;
	inn 		: 			IN STD_LOGIC;
	ut 		: 			OUT STD_LOGIC
);
END flip_flop;

ARCHITECTURE rtl OF flip_flop IS

BEGIN
	PROCESS (clk, reset)
	BEGIN
		IF (reset = '1') THEN
			ut <= '0';
		ELSIF (clk'EVENT and clk = '1') THEN
			ut <= inn;
		END IF;
	END PROCESS;
END rtl;

--library IEEE;
--use IEEE.STD_LOGIC_1164.ALL;
-- 
--entity flip_flop is
--   port
--   (
--		clk, reset, d : in std_logic;
--		q : out std_logic
--   );
--end entity flip_flop;
--
--architecture rtl of flip_flop is
--begin
--process(clk, reset)
--begin
--  if (reset = '1') then
--    q <= '0';
--  elsif rising_edge(clk) then
--    q <= d;
--  end if;
--end process;
--
--end rtl;