set usb [lindex [get_hardware_names] 0]
set device_name [lindex [get_device_names -hardware_name $usb] 0]


#IR scan codes:  001 -> push
#                010 -> pop
#                011 -> flush
#                100 -> reset
#                111 -> normal

# proc push {value} {
#
#    global device_name usb
#    
#    open_device -device_name $device_name -hardware_name $usb
#   
#    
##   if {$value > 256} {
##	return "value entered exceeds 8 bits" }
#   
#	 set push_value [hex2bin $value]
##    set push_value [int2bits $value]
##    set diff [expr {8 - [string length $push_value]%8}]
##    
##    if {$diff != 8} {
##	set push_value [format %0${diff}d$push_value 0]
##    }
#
#    puts $push_value
#
#    device_lock -timeout 10000
#    device_virtual_ir_shift -instance_index 0 -ir_value 1 -no_captured_ir_value
#    
#
#    device_virtual_dr_shift -instance_index 0 -dr_value $push_value -length 64 -no_captured_dr_value
#    device_unlock
#    close_device
# }

 proc push {} {
	 set lst [list "8" "16" "32" "64" "128" "200"] 
	 set infile [open "testmatrise20hex.txt" r]
	 #set i 0
	 #set value 1
	 
	 
	 global device_name usb
	 
    open_device -device_name $device_name -hardware_name $usb

   # if {$value > 18446744073709551616} {
	# return "value entered exceeds 64 bits" }
   
	 #int2bits
	 device_lock -timeout 10000
	 device_virtual_ir_shift -instance_index 0 -ir_value 1 -no_captured_ir_value
	 
	 while { [gets $infile value] >= 0 } {
    set push_value [hex2bin $value]
    # set diff [expr {64 - [string length $push_value]%64}]
    
    # if {$diff != 64} {
	 # set push_value [format %0${diff}d$push_value 0]
    # }
	 
    # puts $push_value
	 puts $value

    #device_lock -timeout 10000
    #device_virtual_ir_shift -instance_index 0 -ir_value 1 -no_captured_ir_value
    

    device_virtual_dr_shift -instance_index 0 -dr_value $push_value -length 64 -no_captured_dr_value
    }
	 device_unlock
	 
    close_device
 }

proc pop {} {
    global device_name usb
    variable x
	 set i 0
	 set outfile [open "out20.txt" a+]
	 open_device -device_name $device_name -hardware_name $usb
	 device_lock -timeout 10000
	
	 
	 while {$i < 20} {
	   device_virtual_ir_shift -instance_index 0 -ir_value 2 -no_captured_ir_value
		set x [device_virtual_dr_shift -instance_index 0 -length 64]
		puts $x
		set hex [bin2hex $x]
		puts $outfile $hex
		incr i
	 }
	 
	 close $outfile
	 device_unlock
	 close_device
	 
	# return $hex
}

# proc f {} {
#	set outfile [open "out.txt" a+]
#	set i 0
#	while {$i < 4} {
#		set line [pop]
#		puts $outfile $line
#		incr i
#	}
#	close $outfile
# }

proc flushfifo {} {
    global device_name usb
    open_device -device_name $device_name -hardware_name $usb
    device_lock -timeout 10000
    device_virtual_ir_shift -instance_index 0 -ir_value 3 -no_captured_ir_value
    device_virtual_ir_shift -instance_index 0 -ir_value 7 -no_captured_ir_value
    device_unlock
    close_device
}

proc end {} {

    close_device
}
   
proc reset {} {
	 global device_name usb
    open_device -device_name $device_name -hardware_name $usb
    device_lock -timeout 10000
    device_virtual_ir_shift -instance_index 0 -ir_value 0 -no_captured_ir_value
    device_unlock
    close_device
}


proc int2bits {i} {
    
     set res ""
     while {$i>0} {
         set res [expr {$i%2}]$res
         set i [expr {$i/2}]
     }
     if {$res==""} {set res 0}
     return $res
 }


 proc hex2bin {hex} {
  binary scan [binary format H* $hex] B* bin
  return $bin
}


proc bin2hex {bin} {
    array set t {
	0000 0 0001 1 0010 2 0011 3 0100 4
	0101 5 0110 6 0111 7 1000 8 1001 9
	1010 a 1011 b 1100 c 1101 d 1110 e 1111 f
    }
    set diff [expr {4-[string length $bin]%4}]
    if {$diff != 4} {
        set bin [format %0${diff}d$bin 0]
    }
    regsub -all .... $bin {$t(&)} hex
    return [subst $hex]
}
