LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY reg IS

PORT (
	clk 		: 			IN STD_LOGIC;
	reset    :        IN STD_LOGIC;
	inn 		: 			IN STD_LOGIC_VECTOR(63 DOWNTO 0);
	ut 		: 			OUT STD_LOGIC_VECTOR(63 DOWNTO 0)
);
END reg;

ARCHITECTURE rtl OF reg IS

BEGIN
	PROCESS (clk, reset)
	BEGIN
		IF (reset = '1') THEN
			ut <= (OTHERS => '0');
		ELSIF (clk'EVENT and clk = '1') THEN
			ut <= inn;
		END IF;
	END PROCESS;
END rtl;