library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity shift_reg_en_test is
end;

architecture BENCH of shift_reg_en_test is
--component
	component shift_reg_en
		generic
		(
		length : integer := 12
		);

		port
		(
			clk : in std_logic;
			reset : in std_logic;
			enable : in std_logic;
			inn : in std_logic;
			ut : out std_logic
		);
		end component;
--signal
			
			signal reset, clk, inn, ut : std_logic;
			
			constant length : integer := 12;
			
			signal temp_clk : std_logic := '1';
			constant period : Time := 10 NS;
begin
--stimuli
  reset <= '1', '0' after 30 NS, '1' after 250 NS, '0' after 260 NS;
  
  
  inn <= '0', '1' after 50 NS, '0' after 70 NS, '1' after 100 NS;
  
  --calculate <= '0', '1' after 40 NS, '0' after 250 NS;--, '1' after 450 NS, '0' after 460 NS;
  
  
  
  --2
 
  clk <= temp_clk;
   
   clk_process : process(clk, temp_clk)
   begin
	  temp_clk  <= not temp_clk after 5 NS;
	end process;
	
--instansiate component
shift_reg_en11 : shift_reg_en 
	generic map( length => length)
	PORT MAP (
		clk => clk,
		reset => reset,
		enable => inn,
		inn => inn,
		ut => ut
	);

end BENCH;