library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity test_shift_reg is
end;

architecture BENCH of test_shift_reg is

 component shift_reg
   generic (length : integer
			);
	PORT (
		clk 		: 			IN STD_LOGIC;
		inn 		: 			IN STD_LOGIC;
		tap1		:        OUT STD_LOGIC;
		ut 		: 			OUT STD_LOGIC
	);
  end component;

  signal inn, clk : STD_LOGIC;
 
  constant length : integer := 13;
 
  signal ut : std_logic;
  signal tap1 : std_logic;
  constant period : Time := 10 NS;
  signal temp_clk : std_logic := '1';
begin

 --reset <= '1', '0' after 30 NS;
  
  inn <= '0', '1' after 50 NS, '0' after 100 NS, '1' after 150 NS;

    clk <= temp_clk;
   
	clk_process : process(clk, temp_clk)
   begin
		  temp_clk  <= not temp_clk after 5 NS;
	end process;
  
  shift_reg1 : shift_reg
  GENERIC MAP (length => length)
  PORT MAP (
		clk => clk,
		inn => inn,
		tap1 => tap1,
		ut	 => ut
	);

end BENCH;